Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TextIndicator/text-indicator.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TextIndicator/text-indicator.js	(révision 0)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TextIndicator/text-indicator.js	(révision 0)
@@ -0,0 +1,103 @@
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+/*
+ * TextIndicator Plugin for TYPO3 htmlArea RTE
+ *
+ * TYPO3 SVN ID: $Id: text-indicator.js 6539 2009-11-25 14:49:14Z stucki $
+ */
+TextIndicator = HTMLArea.Plugin.extend({
+		
+	constructor : function(editor, pluginName) {
+		this.base(editor, pluginName);
+	},
+	
+	/*
+	 * This function gets called by the class constructor
+	 */
+	configurePlugin : function (editor) {
+		/*
+		 * Registering plugin "About" information
+		 */
+		var pluginInformation = {
+			version		: "1.0",
+			developer	: "Stanislas Rolland",
+			developerUrl	: "http://www.sjbr.ca/",
+			copyrightOwner	: "Stanislas Rolland",
+			sponsor		: "SJBR",
+			sponsorUrl	: "http://www.sjbr.ca/",
+			license		: "GPL"
+		};
+		this.registerPluginInformation(pluginInformation);
+		
+		/*
+		 * Registering the indicator
+		 */
+		var buttonId = 'TextIndicator';
+		var textConfiguration = {
+			id: buttonId,
+			cls: 'indicator',
+			text: 'A',
+			tooltip: this.localize(buttonId.toLowerCase())
+		};
+		this.registerText(textConfiguration);
+		return true;
+	 },
+
+	/*
+	 * This function gets called when the toolbar is updated
+	 */
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		var editor = this.editor;
+		if (mode === 'wysiwyg' && editor.isEditable()) {
+			var doc = editor._doc;
+			try {
+				var style = {
+					backgroundColor: HTMLArea._makeColor(doc.queryCommandValue((HTMLArea.is_ie || HTMLArea.is_safari) ? 'BackColor' : 'HiliteColor')),
+					color: HTMLArea._makeColor(doc.queryCommandValue('ForeColor')),
+					fontFamily: doc.queryCommandValue('FontName'),
+					fontWeight: 'normal',
+					fontStyle: 'normal'
+				};
+					// Mozilla
+				if (/transparent/i.test(style.backgroundColor)) {
+					style.backgroundColor = HTMLArea._makeColor(doc.queryCommandValue('BackColor'));
+				}
+				try {
+					style.fontWeight = doc.queryCommandState('Bold') ? 'bold' : 'normal';
+				} catch(e) {
+					style.fontWeight = 'normal';
+				}
+				try {
+					style.fontStyle = doc.queryCommandState('Italic') ? 'italic' : 'normal';
+				} catch(e) {
+					style.fontStyle = 'normal';
+				}
+				button.getEl().setStyle(style);
+			} catch (e) { }
+		}
+	}
+});
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TextStyle/text-style.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TextStyle/text-style.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TextStyle/text-style.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2007-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2007-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -112,15 +112,22 @@
 		/* 
 		 * Registering the dropdown list
 		 */
-		var buttonId = "TextStyle";
+		var buttonId = 'TextStyle';
+		var fieldLabel = this.pageTSconfiguration.fieldLabel;
+		if (Ext.isEmpty(fieldLabel) && this.isButtonInToolbar('I[text_style]')) {
+			fieldLabel = this.localize('text_style');
+		}
 		var dropDownConfiguration = {
-			id		: buttonId,
-			tooltip		: this.localize(buttonId + "-Tooltip"),
-			textMode	: false,
-			options		: {"":""},
-			action		: "onChange",
-			refresh		: "generate",
-			context		: null
+			id: buttonId,
+			tooltip: this.localize(buttonId + '-Tooltip'),
+			fieldLabel: fieldLabel,
+			width: this.pageTSconfiguration.width ? this.pageTSconfiguration.width : 'auto',
+			listWidth:  this.pageTSconfiguration.listWidth ? this.pageTSconfiguration.listWidth : 250,
+			maxHeight: this.pageTSconfiguration.maxHeight ? this.pageTSconfiguration.maxHeight : 300,
+			options: [[this.localize('No style'), 'none']],
+			action: 'onChange',
+			storeFields: [ { name: 'text'}, { name: 'value'}, { name: 'style'} ],
+			tpl: '<tpl for="."><div ext:qtip="{value}" style="{style}text-align:left;font-size:11px;" class="x-combo-list-item">{text}</div></tpl>'
 		};
 		this.registerDropDown(dropDownConfiguration);
 		
@@ -145,15 +152,14 @@
 	/*
 	 * This function gets called when some style in the drop-down list applies it to the highlighted textt
 	 */
-	onChange : function (editor, buttonId) {
-		var select = document.getElementById(this.editor._toolbarObjects[buttonId].elementId);
-		var className = select.value;
+	onChange : function (editor, combo, record, index) {
+		var className = combo.getValue();
 		var classNames = null;
 		var fullNodeSelected = false;
 		
 		this.editor.focusEditor();
 		var selection = this.editor._getSelection();
-		var statusBarSelection = this.editor.getPluginInstance("StatusBar") ? this.editor.getPluginInstance("StatusBar").getSelection() : null;
+		var statusBarSelection = this.editor.statusBar ? this.editor.statusBar.getSelection() : null;
 		var range = this.editor._createRange(selection);
 		var parent = this.editor.getParentElement();
 		var selectionEmpty = this.editor._selectionEmpty(selection);
@@ -213,7 +219,9 @@
 	 * This function gets called when the plugin is generated
 	 * Get the classes configuration and initiate the parsing of the style sheets
 	 */
-	onGenerate : function() {
+	onGenerate: function() {
+			// Monitor editor changing mode
+		this.editor.iframe.mon(this.editor, 'modeChange', this.onModeChange, this);
 		this.generate(this.editor, "TextStyle");
 	},
 	
@@ -226,11 +234,7 @@
 			this.updateToolbar(dropDownId);
 		} else {
 			if (this.cssTimeout) {
-				if (editor._iframe.contentWindow) {
-					editor._iframe.contentWindow.clearTimeout(this.cssTimeout);
-				} else {
-					window.clearTimeout(this.cssTimeout);
-				}
+				window.clearTimeout(this.cssTimeout);
 				this.cssTimeout = null;
 			}
 			if (this.classesUrl && (typeof(HTMLArea.classesLabels) === "undefined")) {
@@ -243,8 +247,7 @@
 	buildCssArray : function(editor, dropDownId) {
 		this.cssArray = this.parseStyleSheet();
 		if (!this.cssLoaded && (this.cssParseCount < 17)) {
-			var buildCssArrayLaterFunctRef = this.makeFunctionReference("buildCssArray");
-			this.cssTimeout = editor._iframe.contentWindow ? editor._iframe.contentWindow.setTimeout(buildCssArrayLaterFunctRef, 200) : window.setTimeout(buildCssArrayLaterFunctRef, 200);
+			this.cssTimeout = this.buildCssArray.defer(200, this, [editor, dropDownId]);
 			this.cssParseCount++;
 		} else {
 			this.cssTimeout = null;
@@ -393,9 +396,9 @@
 	/*
 	 * This function gets called when the toolbar is being updated
 	 */
-	onUpdateToolbar : function() {
-		if (this.getEditorMode() === "wysiwyg" && this.editor.isEditable()) {
-			this.generate(this.editor, "TextStyle");
+	onUpdateToolbar: function(button, mode, selectionEmpty, ancestors) {
+		if (mode === "wysiwyg" && this.editor.isEditable()) {
+			this.generate(this.editor, button.itemId);
 		}
 	},
 	
@@ -407,7 +410,7 @@
 		if (this.getEditorMode() === "wysiwyg" && this.editor.isEditable()) {
 			var tagName = false, classNames = Array(), fullNodeSelected = false;
 			var selection = editor._getSelection();
-			var statusBarSelection = editor.getPluginInstance("StatusBar") ? editor.getPluginInstance("StatusBar").getSelection() : null;
+			var statusBarSelection = editor.statusBar ? editor.statusBar.getSelection() : null;
 			var range = editor._createRange(selection);
 			var parent = editor.getParentElement(selection);
 			var ancestors = editor.getAllAncestors();
@@ -446,122 +449,144 @@
 			if (!disabled && !tagName) {
 				tagName = "span";
 			}
-			
 			this.updateValue(dropDownId, tagName, classNames, selectionEmpty, fullNodeSelected, disabled);
+		} else {
+			var dropDown = this.getButton(dropDownId);
+			if (dropDown) {
+				dropDown.setDisabled(!dropDown.textMode);
+			}
 		}
 	},
 
+	/*
+	 * This function reinitializes the options of the dropdown
+	 */
+	initializeDropDown : function (dropDown) {
+		var store = dropDown.getStore();
+		store.removeAll(true);
+		store.insert(0, new store.recordType({
+			text: this.localize('No style'),
+			value: 'none'
+		}));
+		dropDown.setValue('none');
+	},
+
+	/*
+	 * This function sets the selected option of the dropDown box
+	 */
+	setSelectedOption : function (dropDown, classNames, noUnknown, defaultClass) {
+		var store = dropDown.getStore();
+		var index = store.findExact('value', classNames[classNames.length-1]);
+		if (index != -1) {
+			dropDown.setValue(classNames[classNames.length-1]);
+			if (!defaultClass) {
+				store.getAt(0).set('text', this.localize('Remove style'));
+			}
+		}
+		if (index == -1 && !noUnknown) {
+			store.add(new store.recordType({
+				text: this.localize('Unknown style'),
+				value: classNames[classNames.length-1]
+			}));
+			index = store.getCount()-1;
+			dropDown.setValue(classNames[classNames.length-1]);
+			if (!defaultClass) {
+				store.getAt(0).set('text', this.localize('Remove style'));
+			}
+		}
+		store.each(function (option) {
+			if (("," + classNames.join(",") + ",").indexOf("," + option.get('value') + ",") != -1 && store.indexOf(option) != index) {
+				store.removeAt(store.indexOf(option));
+			}
+			return true;
+		});
+	},
+
 	updateValue : function(dropDownId, tagName, classNames, selectionEmpty, fullNodeSelected, disabled) {
 		var editor = this.editor;
-		var select = document.getElementById(editor._toolbarObjects[dropDownId]["elementId"]);
-		var cssArray = new Array();
-		
-		while(select.options.length > 0) {
-			select.options[select.length-1] = null;
-		}
-		select.options[0] = new Option(this.localize("No style"),"none");
-		if (this.REInlineTags.test(tagName)) {
-				// Get classes allowed for all tags
-			if (typeof(this.cssArray["all"]) !== "undefined") {
-				var cssArrayAll = this.cssArray.all;
-				if (this.tags && this.tags[tagName] && this.tags[tagName].allowedClasses) {
-					var allowedClasses = this.tags[tagName].allowedClasses;
-					for (var cssClass in cssArrayAll) {
-						if (cssArrayAll.hasOwnProperty(cssClass) && allowedClasses.test(cssClass)) {
-							cssArray[cssClass] = cssArrayAll[cssClass];
+		var dropDown = this.getButton(dropDownId);
+		if (dropDown) {
+			var store = dropDown.getStore();
+			var cssArray = new Array();
+			this.initializeDropDown(dropDown);
+			if (this.REInlineTags.test(tagName)) {
+					// Get classes allowed for all tags
+				if (typeof(this.cssArray["all"]) !== "undefined") {
+					var cssArrayAll = this.cssArray.all;
+					if (this.tags && this.tags[tagName] && this.tags[tagName].allowedClasses) {
+						var allowedClasses = this.tags[tagName].allowedClasses;
+						for (var cssClass in cssArrayAll) {
+							if (cssArrayAll.hasOwnProperty(cssClass) && allowedClasses.test(cssClass)) {
+								cssArray[cssClass] = cssArrayAll[cssClass];
+							}
 						}
-					}
-				} else {
-					for (var cssClass in cssArrayAll) {
-						if (cssArrayAll.hasOwnProperty(cssClass)) {
-							cssArray[cssClass] = cssArrayAll[cssClass];
+					} else {
+						for (var cssClass in cssArrayAll) {
+							if (cssArrayAll.hasOwnProperty(cssClass)) {
+								cssArray[cssClass] = cssArrayAll[cssClass];
+							}
 						}
 					}
 				}
-			}
-				// Merge classes allowed for tagName and sort the array
-			if (typeof(this.cssArray[tagName]) !== "undefined") {
-				var cssArrayTagName = this.cssArray[tagName];
-				if (this.tags && this.tags[tagName] && this.tags[tagName].allowedClasses) {
-					var allowedClasses = this.tags[tagName].allowedClasses;
-					for (var cssClass in cssArrayTagName) {
-						if (cssArrayTagName.hasOwnProperty(cssClass) && allowedClasses.test(cssClass)) {
-							cssArray[cssClass] = cssArrayTagName[cssClass];
+					// Merge classes allowed for tagName and sort the array
+				if (typeof(this.cssArray[tagName]) !== "undefined") {
+					var cssArrayTagName = this.cssArray[tagName];
+					if (this.tags && this.tags[tagName] && this.tags[tagName].allowedClasses) {
+						var allowedClasses = this.tags[tagName].allowedClasses;
+						for (var cssClass in cssArrayTagName) {
+							if (cssArrayTagName.hasOwnProperty(cssClass) && allowedClasses.test(cssClass)) {
+								cssArray[cssClass] = cssArrayTagName[cssClass];
+							}
 						}
+					} else {
+						for (var cssClass in cssArrayTagName) {
+							if (cssArrayTagName.hasOwnProperty(cssClass)) {
+								cssArray[cssClass] = cssArrayTagName[cssClass];
+							}
+						}
 					}
-				} else {
-					for (var cssClass in cssArrayTagName) {
-						if (cssArrayTagName.hasOwnProperty(cssClass)) {
-							cssArray[cssClass] = cssArrayTagName[cssClass];
+					var sortedCssArray = new Object();
+					var cssArrayKeys = new Array();
+					for (var cssClass in cssArray) {
+						if (cssArray.hasOwnProperty(cssClass)) {
+							cssArrayKeys.push(cssClass);
 						}
 					}
+					function compare(a, b) {
+						x = cssArray[a];
+						y = cssArray[b];
+						return ((x < y) ? -1 : ((x > y) ? 1 : 0));
+					}
+					cssArrayKeys = cssArrayKeys.sort(compare);
+					for (var i = 0; i < cssArrayKeys.length; ++i) {
+						sortedCssArray[cssArrayKeys[i]] = cssArray[cssArrayKeys[i]];
+					}
+					cssArray = sortedCssArray;
 				}
-				var sortedCssArray = new Object();
-				var cssArrayKeys = new Array();
 				for (var cssClass in cssArray) {
-					if (cssArray.hasOwnProperty(cssClass)) {
-						cssArrayKeys.push(cssClass);
-					}
-				}
-				function compare(a, b) {
-					x = cssArray[a];
-					y = cssArray[b];
-					return ((x < y) ? -1 : ((x > y) ? 1 : 0));
-				}
-				cssArrayKeys = cssArrayKeys.sort(compare);
-				for (var i = 0; i < cssArrayKeys.length; ++i) {
-					sortedCssArray[cssArrayKeys[i]] = cssArray[cssArrayKeys[i]];
-				}
-				cssArray = sortedCssArray;
-			}
-			for (var cssClass in cssArray) {
-				if (cssArray.hasOwnProperty(cssClass) && cssArray[cssClass]) {
-					if (cssClass == "none") {
-						select.options[0] = new Option(cssArray[cssClass], cssClass);
-					} else {
-						select.options[select.options.length] = new Option(cssArray[cssClass], cssClass);
-						if (!editor.config.disablePCexamples && HTMLArea.classesValues && HTMLArea.classesValues[cssClass] && !HTMLArea.classesNoShow[cssClass]) {
-							select.options[select.options.length-1].setAttribute("style", HTMLArea.classesValues[cssClass]);
+					if (cssArray.hasOwnProperty(cssClass) && cssArray[cssClass]) {
+						if (cssClass == 'none') {
+							store.getAt(0).set('text', cssArray[cssClass]);
+						} else {
+							store.add(new store.recordType({
+								text: cssArray[cssClass],
+								value: cssClass,
+								style: (!this.editor.config.disablePCexamples && HTMLArea.classesValues && HTMLArea.classesValues[cssClass] && !HTMLArea.classesNoShow[cssClass]) ? HTMLArea.classesValues[cssClass] : null
+							}));
 						}
 					}
 				}
-			}
-			
-			select.selectedIndex = 0;
-			if (classNames.length && (selectionEmpty || fullNodeSelected)) {
-				for (i = select.options.length; --i >= 0;) {
-					if (classNames[classNames.length-1] == select.options[i].value) {
-						select.options[i].selected = true;
-						select.selectedIndex = i;
-						select.options[0].text = this.localize("Remove style");
-						break;
-					}
+				if (classNames.length && (selectionEmpty || fullNodeSelected)) {
+					this.setSelectedOption(dropDown, classNames);
 				}
-				if (select.selectedIndex == 0) {
-					select.options[select.options.length] = new Option(this.localize("Unknown style"), classNames[classNames.length-1]);
-					select.options[select.options.length-1].selected = true;
-					select.selectedIndex = select.options.length-1;
-				}
-				for (i = select.options.length; --i >= 0;) {
-					if (("," + classNames.join(",") + ",").indexOf("," + select.options[i].value + ",") !== -1) {
-						if (select.selectedIndex != i) {
-							select.options[i] = null;
-						}
-					}
-				}
 			}
+			dropDown.setDisabled(!(store.getCount()>1) || disabled);
 		}
-		select.disabled = !(select.options.length>1) || disabled;
-		select.className = "";
-		if (select.disabled) {
-			select.className = "buttonDisabled";
-		}
 	},
-	
 	/*
 	 * This function gets called when the editor has changed its mode to "wysiwyg"
 	 */
-	onMode : function(mode) {
+	onModeChange: function(mode) {
 		if (mode === "wysiwyg" && this.editor.isEditable()) {
 			this.generate(this.editor, "TextStyle");
 		}
